package com.example.fuzzControll.controller;

import com.example.fuzzControll.pojo.vo.AjaxResult;
import com.example.fuzzControll.pojo.vo.TestEntity;
import com.example.fuzzControll.service.GenerateMethodService;
import com.example.fuzzControll.service.MutationService;
import com.example.fuzzControll.service.ProtocolTemplateService;
import com.example.fuzzControll.service.VulnerabilityTypeService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;
import java.util.Map;

/**
 * 不同类型的测试方法
 */
@RestController
@RequestMapping("/testClass")
public class TestClassController {
    @Autowired
    GenerateMethodService generateMethodService;
    @Autowired
    MutationService mutationService;
    @Autowired
    ProtocolTemplateService protocolTemplateService;
    @Autowired
    VulnerabilityTypeService vulnerabilityTypeService;
    /**
     * 模板
     */
    @RequestMapping(value = "/protocolTemplate", method = RequestMethod.POST)
    public AjaxResult protocolTemplate(@RequestBody TestEntity testEntity) {
        try {
            Map<String, List<String>> result = protocolTemplateService.generation(testEntity);
            return AjaxResult.success(result==null?"模板文件生成未成功运行":result);
        } catch (Exception e) {
            return AjaxResult.error("模板文件生成失败！");
        }
    }

    /**
     *生成方法
     */
    @RequestMapping(value = "/generate", method = RequestMethod.POST)
    public AjaxResult generate(@RequestBody TestEntity testEntity) {
        try {
            Map<String, List<String>> result = generateMethodService.generation(testEntity);
            return AjaxResult.success(result==null?"生成方法未成功运行":result);
        } catch (Exception e) {
            return AjaxResult.error("生成方法使用失败！");
        }
    }

    /**
     *变异方法
     */
    @RequestMapping(value = "/mutation", method = RequestMethod.POST)
    public AjaxResult mutation(@RequestBody TestEntity testEntity) {
        try {
            Map<String, List<String>> result = mutationService.generation(testEntity);
            return AjaxResult.success(result==null?"mutationTest未成功运行":result);
        } catch (Exception e) {
            return AjaxResult.error("mutationTest失败！");
        }
    }

    /**
     *漏洞类型
     */
    @RequestMapping(value = "/vulnerabilityType", method = RequestMethod.POST)
    public AjaxResult upload(@RequestBody TestEntity testEntity) {
        try {
            Map<String, List<String>> result = vulnerabilityTypeService.generation(testEntity);
            return AjaxResult.success(result==null?"漏洞类型未成功运行":result);
        } catch (Exception e) {
            return AjaxResult.error("漏洞类型测试失败！");
        }
    }
}
